# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPolicyResult',
    'AwaitableGetPolicyResult',
    'get_policy',
    'get_policy_output',
]

@pulumi.output_type
class GetPolicyResult:
    """
    A collection of values returned by getPolicy.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetPolicyResult(GetPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPolicyResult(
            id=self.id,
            name=self.name)


def get_policy(name: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPolicyResult:
    """
    The `get_policy` data source can be used to discover the UUID of a
    storage policy. This can then be used with other resources or data sources that
    use a storage policy.

    > **NOTE:** Storage policies are not supported on direct ESXi hosts and
    requires vCenter Server.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vsphere as vsphere

    prod_platinum_replicated = vsphere.get_policy(name="prod_platinum_replicated")
    dev_silver_nonreplicated = vsphere.get_policy(name="dev_silver_nonreplicated")
    ```


    :param str name: The name of the storage policy.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vsphere:index/getPolicy:getPolicy', __args__, opts=opts, typ=GetPolicyResult).value

    return AwaitableGetPolicyResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))


@_utilities.lift_output_func(get_policy)
def get_policy_output(name: Optional[pulumi.Input[str]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPolicyResult]:
    """
    The `get_policy` data source can be used to discover the UUID of a
    storage policy. This can then be used with other resources or data sources that
    use a storage policy.

    > **NOTE:** Storage policies are not supported on direct ESXi hosts and
    requires vCenter Server.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vsphere as vsphere

    prod_platinum_replicated = vsphere.get_policy(name="prod_platinum_replicated")
    dev_silver_nonreplicated = vsphere.get_policy(name="dev_silver_nonreplicated")
    ```


    :param str name: The name of the storage policy.
    """
    ...
